Package twisted :: Package internet :: Module interfaces :: Class IReactorCore

[show private | hide private]
[frames | no frames]

## Class IReactorCore

    Interface --+
                |
               IReactorCore

Core methods that a Reactor must implement.

Method Summary
| ``addSystemEventTrigger`(self, phase, eventType, callable, *args, **kw)` Add a function to be called when a system event occurs.
| ``crash`(self)` Stop the main loop *immediately*, without firing any system events.
| ``fireSystemEvent`(self, eventType)` Fire a system-wide event.
| ``iterate`(self, delay)` Run the main loop's I/O polling function for a period of time.
| ``removeSystemEventTrigger`(self, triggerID)` Removes a trigger added with addSystemEventTrigger.
| ``resolve`(self, name, timeout)` Return a `Deferred`that will resolve a hostname.
| ``run`(self)` Fire 'startup' System Events, move the reactor to the 'running' state, then run the main loop until it is stopped with stop() or crash().
| ``stop`(self)` Fire 'shutdown' System Events, which will move the reactor to the 'stopped' state and cause reactor.run() to exit.

Method Details

### addSystemEventTrigger(self, phase, eventType, callable, *args, **kw)

Add a function to be called when a system event occurs.

Each "system event" in Twisted, such as 'startup', 'shutdown', and 'persist', has 3 phases: 'before', 'during', and 'after' (in that order, of course). These events will be fired internally by the Reactor.

An implementor of this interface must only implement those events described here.

Callbacks registered for the "before" phase may return either None or a Deferred. The "during" phase will not execute until all of the Deferreds from the "before" phase have fired.

Once the "during" phase is running, all of the remaining triggers must execute; their return values must be ignored.

  Parameters:
    `phase` - a time to call the event -- either the string 'before', 'after', or 'during', describing when to call it relative to the event's execution.
    `eventType` - this is a string describing the type of event.
    `callable` - the object to call before shutdown.
    `args` - the arguments to call it with.
    `kw` - the keyword arguments to call it with.
  Returns:
    an ID that can be used to remove this call with removeSystemEventTrigger.

### crash(self)

Stop the main loop *immediately*, without firing any system events.

This is named as it is because this is an extremely "rude" thing to do; it is possible to lose data and put your system in an inconsistent state by calling this. However, it is necessary, as sometimes a system can become wedged in a pre-shutdown call.

### fireSystemEvent(self, eventType)

Fire a system-wide event.

System-wide events are things like 'startup', 'shutdown', and 'persist'.

### iterate(self, delay=0)

Run the main loop's I/O polling function for a period of time.

This is most useful in applications where the UI is being drawn "as fast as possible", such as games. All pending `IDelayedCall`s will be called.

### removeSystemEventTrigger(self, triggerID)

Removes a trigger added with addSystemEventTrigger.

  Parameters:
    `triggerID` - a value returned from addSystemEventTrigger.

### resolve(self, name, timeout=10)

Return a `Deferred` that will resolve a hostname.

### run(self)

Fire 'startup' System Events, move the reactor to the 'running' state, then run the main loop until it is stopped with stop() or crash().

### stop(self)

Fire 'shutdown' System Events, which will move the reactor to the 'stopped' state and cause reactor.run() to exit.

Generated by Epydoc 1.1 on Sat Feb 15 21:17:52 2003 | http://epydoc.sf.net